/*
	md64.c: mette il margine destro a 64 (come wp)
*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>

#define MAX	128

extern int errno;

long filelength(int handle)
{
	struct stat *buffer;

	if (fstat(handle, buffer) == 0)
	{
		return(buffer->st_size);
	}
	else
	{
		printf("filesize = %d\n", errno);
		printf("Errore %d in filelength\n", errno);
		return(1L);
	}
}

int main(int argc, char *argv[])
{
	char *nonposso = "non posso aprire";
	unsigned char c, linea[MAX], resto[MAX];
	short int cont = 0, i=0, j=0, lung=0;
	long len = 0L, gcont = 0L;

	FILE *fi, *fo;

	if (argc != 3)
	{
		printf("uso: %s file-in file-out\n", argv[0]);
		exit(1);
	}
	if (fi = fopen(argv[1], "r"))
	{
		if (fo = fopen(argv[2], "w"))
		{
			len = filelength(fileno(fi));
			while (((c = fgetc(fi)) != EOF) && (gcont <= len))
			{
				++gcont;
  				linea[cont] = c;
				if (c == 0)
					c = 32;
				if ((c == '\n') || (c == '\r') || (gcont > len))
				{
					linea[cont+1] = '\0';
					lung = strlen(linea);
					linea[lung-1] = '\0';
#ifdef TEST
					fprintf(fo,"%s{1}\n", linea);
					fprintf(fo,"{c=%d lung=%d}\n", c, lung);
#else
					fprintf(fo,"%s\n",linea);
#endif
					cont = 0;
				}
				else
				{
					if (cont > 63)
					{
						linea[cont+1] = '\0';
						lung = strlen(linea);
						if (c < 33 || c == '.' || c==',' || c=='-')
						{
							linea[lung] = '\0';
#ifdef TEST
							fprintf(fo,"%s{2}\n", linea);
							fprintf(fo,"{c=%d lung=%d}\n",c,lung);
#else
							fprintf(fo,"%s\n",linea);
#endif
							cont = 0;
						}
						else
						{
							for (i=lung-1,j=0; linea[i]!=32 && i>=0; i--,j++)
							{
								resto[j] = linea[i];
							}
							resto[j] = '\0';
							linea[i] = '\0';
#ifdef TEST
							fprintf(fo,"%s{3}\n",linea);
							fprintf(fo,"{resto=%s lung=%d i=%d j=%d}\n", resto, lung, i, j);
#else
							fprintf(fo,"%s\n", linea);					
#endif
							for (i=j-1, cont=0; i>=0; i--,cont++)
							{
								linea[cont] = resto[i];
							}
						}
					}
					else
						++cont;
				}
			}
			fclose(fo);
		}
		else
		{
			printf("%s %s in scrittura, errno %d\n", nonposso, argv[2], errno);
		}
		fclose(fi);
	}
	else
	{
		printf("%s %s in lettura, errno %d\n", nonposso, argv[1], errno);
	}
	exit(0);
}

