/* mw2asc.c: converte da MAC-word solo testo a ASCII */

#include <stdio.h>
#include <string.h>
#define MAX	256

#define USCITA	"noname.asc"

main(argc, argv)
int argc;
char *argv[];
{
	void copia(FILE *fi, FILE *fo, unsigned char *pvetc);
	FILE *fi, *fo;
	short int lung = 0, error = 0, i = 0;
	unsigned char c;
	char nomefile[MAX], uscita[MAX];
	unsigned char vetc[MAX], *pvetc = vetc;
	unsigned char *fmt0 = "mw2asc: non posso aprire %s\n";

	for (i=0; i<32; i++)
		vetc[i] = 0;
	for (i=32; i<165; i++)
		vetc[i] = i;
	for (i=165; i<256; i++)
		vetc[i] = 0;
	vetc[10] = 10;
	vetc[13] = 13;
	vetc[136] = 133;	/* a grave */
	vetc[141] = 135;	/* c con cediglia */
	vetc[143] = 138;	/* e grave */
	vetc[142] = 130;	/* e acuta */
	vetc[147] = 141;	/* i grave */
	vetc[152] = 149;	/* o grave */
	vetc[153] = 147;	/* o circonflesso */
	vetc[157] = 151;	/* u grave */
	vetc[213] =  39;	/* apice   */
	vetc[233] = 144;	/* E accentata */
	vetc[199] = 174;	/* caporale aperto */
	vetc[200] = 175;	/* caporale chiuso */
	vetc[161] = 167;	/* ordinale */

	if (argc<2 || argc>3)
	{
		printf("uso: mw2asc fileword [fileascii]\n");
		exit(1);
	}
	strcpy(nomefile, argv[1]);
	if (argc == 2)
		strcpy(uscita, USCITA);
	else
		strcpy(uscita, argv[2]);
	if (fi = fopen(nomefile, "r"))
	{
		if (fo = fopen(uscita, "w"))
		{
			copia(fi,fo,pvetc);
			fclose(fo);
		}
		else
			printf(fmt0, uscita);
		fclose(fi);
	}
	else
		printf(fmt0, nomefile);
}
void copia(fi,fo,pvetc)  /* copia i files */
FILE *fi, *fo;
unsigned char *pvetc;
{
	int c;

	while ((c = getc(fi)) != EOF)
		if (c == 233)
			fputs("E'", fo);
		else
		{
			if ((*(pvetc+c)) > 0)
				putc(*(pvetc+c), fo);
		}
}
