/*
	tolower.c: converte un file di testo in minuscolo
*/

#include <stdio.h>
#define	MAX	50

extern int errno;

int main(int argc, char *argv[])
{
	int c;
	char name_in[MAX], name_out[MAX];
	char *fmt0 = "%s: non posso aprire %s (%d)\n";
	FILE *fi, *fo;

	if (argc != 3)
	{
		printf("uso: %s nome.txt nuovo_nome\n", argv[0]);
		exit(1);
	}
	strcpy(name_in, argv[1]);
	strcpy(name_out, argv[2]);
	if (fi = fopen(name_in, "r"))
	{
		if (fo = fopen(name_out, "w"))
		{
			while ((c = fgetc(fi)) != EOF)
			{
				fputc(tolower(c),fo);
			}
		}
		else
		{
			fprintf(stderr, fmt0, argv[0], name_out, errno);
			exit(2);
		}
	}
	else
	{
		fprintf(stderr, fmt0, argv[0], name_in, errno);
		exit(2);
	}
}
