/*
	xw2asc.c:
	converte da Unix word a ASCII
*/

#include <stdio.h>
#include <string.h>

#define USCITA	"noname.asc"

main(argc, argv)
int argc;
char *argv[];
{
	void copia(FILE *fi, FILE *fo, unsigned char *pvetc);
	FILE *fi, *fo;
	short int lung = 0, i = 0, error = 0;
	unsigned char c;
	char nomefile[16], uscita[16];
	unsigned char vetc[256], *pvetc = vetc;
	char *fmt0 = "w2asc: non posso aprire %s\n";

	for (i=0; i<32; i++)
		vetc[i] = 0;
	for (i=32; i<165; i++)
		vetc[i] = i;
	for (i=165; i<256; i++)
		vetc[i] = 0;
	vetc[10] = 10;
	vetc[13] = 13;
	vetc[224] = 133;	/* a grave */
	vetc[232] = 138;	/* e grave */
	vetc[233] = 130;	/* e acuta */
	vetc[236] = 141;	/* i grave */
	vetc[242] = 149;	/* o grave */
	vetc[249] = 151;	/* u grave */

	if (argc<2 || argc>3)
	{
		printf("uso: w2asc fileword [fileascii]\n");
		exit(1);
	}
	strcpy(nomefile, argv[1]);
	if (argc == 2)
		strcpy(uscita, USCITA);
	else
		strcpy(uscita, argv[2]);
	if (fi = fopen(nomefile, "r"))
	{
		if (fo = fopen(uscita, "w"))
		{
			copia(fi,fo,pvetc);
			fclose(fo);
		}
		else
			printf(fmt0, uscita);
		fclose(fi);
	}
	else
		printf(fmt0, nomefile);
}
void copia(fi,fo,pvetc)  /* copia i files */
FILE *fi, *fo;
unsigned char *pvetc;
{
	int c;

	while ((c = getc(fi)) != EOF)
		if ((*(pvetc+c)) > 0)
			putc(*(pvetc+c), fo);
}
