/*
	dos2x.c
	converte un file di testo dos in Unix
*/

#include <stdio.h>
#define	MAX	50

extern int errno;

int main(int argc, char *argv[])
{
	int c;
	char name_in[MAX], name_out[MAX];
	char *fmt0 = "%s: Can't open %s (%d)\n";
	FILE *fi, *fo;

	if (argc != 3)
	{
		printf("usage: %s name.dos name_unix\n", argv[0]);
		exit(1);
	}
	strcpy(name_in, argv[1]);
	strcpy(name_out, argv[2]);
	if (fi = fopen(name_in, "rb"))
	{
		if (fo = fopen(name_out, "wb"))
		{
			while ((c = fgetc(fi)) != EOF)
				if ((c != '\r') && (c != 26))
					fputc(c,fo);
		}
		else
		{
			fprintf(stderr, fmt0, argv[0], name_out, errno);
			exit(2);
		}
	}
	else
	{
		fprintf(stderr, fmt0, argv[0], name_in, errno);
		exit(2);
	}
}
