/*
	ww2asc.c: converte da win-word solo testo a ASCII
*/

#include <stdio.h>
#include <string.h>

#define USCITA	"noname.asc"

void copia(FILE *fi, FILE *fo, unsigned char *pvetc)  /* copia i files */
{
	int c;

	while ((c = getc(fi)) != EOF)
	{
		if ((*(pvetc+c)) > 0)
			putc(*(pvetc+c), fo);
	}
}

int main(int argc, char *argv[])
{
	FILE *fi, *fo;
	short int lung = 0, error = 0;
	unsigned char c;
	int i;
	char nomefile[16], uscita[16];
	unsigned char vetc[256], *pvetc = vetc;
	unsigned char *fmt0 = "ww2asc: non posso aprire %s\n";

	for (i=0; i<32; i++)
		vetc[i] = 0;
	for (i=32; i<165; i++)
		vetc[i] = i;
	for (i=165; i<256; i++)
		vetc[i] = 0;
	vetc[10] = 10;
	vetc[13] = 13;
	vetc[224] = 133;	/* a grave */
	vetc[231] = 135;	/* c con cedille */
	vetc[232] = 138;	/* e grave */
	vetc[233] = 130;	/* e acuta */
	vetc[236] = 141;	/* i grave */
	vetc[242] = 149;	/* o grave */
	vetc[249] = 151;	/* u grave */
/*	vetc[213] =  39;	 apice   */
/*	vetc[233] = 144;	 E accentata */
/*	vetc[199] = 174;	 caporale aperto */
/*	vetc[200] = 175;	 caporale chiuso */
	vetc[176] = 248;	/* ordinale */

	if (argc<2 || argc>3)
	{
		printf("uso: ww2asc fileword [fileascii]\n");
		exit(1);
	}
	strcpy(nomefile, argv[1]);
	if (argc == 2)
		strcpy(uscita, USCITA);
	else
		strcpy(uscita, argv[2]);
	if (fi = fopen(nomefile, "r"))
	{
		if (fo = fopen(uscita, "w"))
		{
			copia(fi,fo,pvetc);
			fclose(fo);
		}
		else
			printf(fmt0, uscita);
		fclose(fi);
	}
	else
		printf(fmt0, nomefile);
}
